package cn.com.qmth.examcloud.core.examwork.dao;

import java.util.List;

import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.data.repository.query.QueryByExampleExecutor;
import org.springframework.transaction.annotation.Transactional;

import cn.com.qmth.examcloud.core.examwork.dao.entity.ExamSpecialSettingsEntity;

public interface ExamSpecialSettingsRepo
		extends
			JpaRepository<ExamSpecialSettingsEntity, Long>,
			QueryByExampleExecutor<ExamSpecialSettingsEntity>,
			JpaSpecificationExecutor<ExamSpecialSettingsEntity> {

	ExamSpecialSettingsEntity findByExamIdAndOrgIdAndCourseIdIsNull(Long examId, Long orgId);

	List<ExamSpecialSettingsEntity> findAllByExamIdAndOrgIdIsNullAndCourseIdIsNull(Long examId);

	List<ExamSpecialSettingsEntity> findAllByExamIdAndCourseIdIsNullAndOrgIdIsNotNull(Long examId);

	@Transactional
	@Modifying
	@Query("update ExamSpecialSettingsEntity set examEnable = :examEnable where examId = :examId")
	void updateExamEnableByExamId(@Param("examId") long examId,
			@Param("examEnable") Boolean examEnable);
}
